
(sde:clear)

(define W 200)

(define Lstripe_pitch 50.0)
(define LNplus_stripe 30.0)
(define LGR_pitch 30.0)
(define LNplus_GR 15.0)
(define gap 20.0)
(define NSTRIPE 2)
(define NGR 3)

(define EXT 200.0)

(define L (+ (* NSTRIPE Lstripe_pitch) (* 1.0 gap) (* NGR LGR_pitch) EXT))

(define Plow 1e12)
(define Nca 1e19)
(define Pan 1e19)

(sdegeo:create-rectangle (position (- 0 L) 0 0) (position L W 0) "Silicon" "RSub")

(define end-active 0)
(if (eq? (modulo NSTRIPE 2) 0)
	(begin
					(define j 1)

		(
			do ((i 1 (+ i 1))) ((> i (inexact->exact (* 0.5 NSTRIPE))))	       
			
			(define refevalname1 (string-append "RefVal_Nplus_" (number->string j) ) )
			(define placename1 (string-append "Place_Nplus_" (number->string j) ) )
			
			(define refevalname2 (string-append "RefVal_Nplus_" (number->string (+ j 1)) ) )
			(define placename2 (string-append "Place_Nplus_" (number->string (+ j 1)) ) )
			(set! j (+ j 2))
			
			(define defname "Nplus")
			(sdedr:define-gaussian-profile defname "PhosphorusActiveConcentration" "PeakPos" 0  "PeakVal" Pan "ValueAtDepth" Plow "Depth" 5 "Gauss"  "Factor" 0.8)

			(sdedr:define-refeval-window refevalname1 "Line"  
				(position (- 0 (+ LNplus_stripe (* 0.5 (- Lstripe_pitch LNplus_stripe)) (* (- i 1) Lstripe_pitch) ) ) 0 0) 
				(position (- 0 (+ (* 0.5 (- Lstripe_pitch LNplus_stripe)) (* (- i 1) Lstripe_pitch) ) ) 0 0) 
			)
			(sdedr:define-analytical-profile-placement placename1 defname refevalname1 "Both" "NoReplace" "Eval")

			(sdedr:define-refeval-window refevalname2 "Line"  
				(position (+ 0 (+ (* 0.5 (- Lstripe_pitch LNplus_stripe)) (* (- i 1) Lstripe_pitch) ) ) 0 0) 
				(position (+ 0 (+ LNplus_stripe (* 0.5 (- Lstripe_pitch LNplus_stripe)) (* (- i 1) Lstripe_pitch) ) ) 0 0) 
			)
			(sdedr:define-analytical-profile-placement placename2 defname refevalname2 "Both" "NoReplace" "Eval")
			
			(set! end-active (+ 0 (+ LNplus_stripe (* 0.5 (- Lstripe_pitch LNplus_stripe)) (* (- i 1) Lstripe_pitch) ) ) )
		)
	)
	(begin
			(define j 1)
			
			(define defname "Nplus")
			(sdedr:define-gaussian-profile defname "PhosphorusActiveConcentration" "PeakPos" 0  "PeakVal" Pan "ValueAtDepth" Plow "Depth" 5 "Gauss"  "Factor" 0.8)
			
			(sdedr:define-refeval-window "RefVal_Nplus_0" "Line"  
				(position (- 0 (* 0.5 LNplus_stripe)) 0 0) 
				(position (+ 0 (* 0.5 LNplus_stripe)) 0 0) 
			)
			(sdedr:define-analytical-profile-placement "Place_Nplus_0" defname "RefVal_Nplus_0" "Both" "NoReplace" "Eval")

		(
			do ((i 1 (+ i 1))) ((> i (inexact->exact (* 0.5 (- NSTRIPE 1)))))	       
			
			(define refevalname1 (string-append "RefVal_Nplus_" (number->string j) ) )
			(define placename1 (string-append "Place_Nplus_" (number->string j) ) )
			
			(define refevalname2 (string-append "RefVal_Nplus_" (number->string (+ j 1)) ) )
			(define placename2 (string-append "Place_Nplus_" (number->string (+ j 1)) ) )
			(set! j (+ j 2))
			

			(sdedr:define-refeval-window refevalname1 "Line"  
				(position (- (* i Lstripe_pitch) (* 0.5 LNplus_stripe) ) 0 0) 
				(position (+ (* i Lstripe_pitch) (* 0.5 LNplus_stripe) ) 0 0) 
			)
			(sdedr:define-analytical-profile-placement placename1 defname refevalname1 "Both" "NoReplace" "Eval")

			(sdedr:define-refeval-window refevalname2 "Line"  
				(position (- 0 (+ (* i Lstripe_pitch) (* 0.5 LNplus_stripe) )) 0 0) 
				(position (- 0 (- (* i Lstripe_pitch) (* 0.5 LNplus_stripe) )) 0 0) 
			)
			(sdedr:define-analytical-profile-placement placename2 defname refevalname2 "Both" "NoReplace" "Eval")
			
			(set! end-active (+ (* i Lstripe_pitch) (* 0.5 LNplus_stripe) ) )
		)
	)
)


(define begin-GR (+ end-active gap))

		(
			do ((i 1 (+ i 1))) ((> i NGR))	       
			
			(define refevalname1 (string-append "RefVal_NGR_" (number->string j) ) )
			(define placename1 (string-append "Place_NGR_" (number->string j) ) )
			
			(define refevalname2 (string-append "RefVal_NGR_" (number->string (+ j 1)) ) )
			(define placename2 (string-append "Place_NGR_" (number->string (+ j 1)) ) )
			(set! j (+ j 2))
			
			(define defname "NGR")
			(sdedr:define-gaussian-profile defname "PhosphorusActiveConcentration" "PeakPos" 0  "PeakVal" Pan "ValueAtDepth" Plow "Depth" 5 "Gauss"  "Factor" 0.8)

			(sdedr:define-refeval-window refevalname1 "Line"  
				(position (- 0 (+ begin-GR LNplus_GR (* 0.5 (- LGR_pitch LNplus_GR)) (* (- i 1) LGR_pitch) ) ) 0 0) 
				(position (- 0 (+ begin-GR (* 0.5 (- LGR_pitch LNplus_GR)) (* (- i 1) LGR_pitch) ) ) 0 0) 
			)
			(sdedr:define-analytical-profile-placement placename1 defname refevalname1 "Both" "NoReplace" "Eval")

			(sdedr:define-refeval-window refevalname2 "Line"  
				(position (+ 0 (+ begin-GR (* 0.5 (- LGR_pitch LNplus_GR)) (* (- i 1) LGR_pitch) ) ) 0 0) 
				(position (+ 0 (+ begin-GR LNplus_GR (* 0.5 (- LGR_pitch LNplus_GR)) (* (- i 1) LGR_pitch) ) ) 0 0) 
			)
			(sdedr:define-analytical-profile-placement placename2 defname refevalname2 "Both" "NoReplace" "Eval")
			
		)


(sdedr:define-refeval-window "RefEval_anode" "Line"  (position (- 0 (+ L 10)) W 0) (position (+ L 10) W 0))

(sdedr:define-gaussian-profile "DopAnode" "BoronActiveConcentration" "PeakPos" 0  "PeakVal" Pan "ValueAtDepth" Plow "Depth" 5 "Gauss"  "Factor" 0.8)
(sdedr:define-analytical-profile-placement "Place_anode" "DopAnode" "RefEval_anode" "Both" "NoReplace" "Eval")


(define Tox 0.5)
(sdegeo:create-rectangle (position (- 0 L) (- 0 Tox) 0) (position L 0 0) "Oxide" "Rox")
		
(sdegeo:create-rectangle (position (- 0 (- end-active 5.0)) (- 0 Tox) 0) (position (- end-active 5.0) 0 0) "Aluminum" "RAl1")
(sdegeo:create-rectangle (position (- 0 (+ end-active 5.0)) (- 0 (+ 0.1 Tox)) 0) (position (+ end-active 5.0) (- 0 Tox) 0) "Aluminum" "RAl2")
		

(sdegeo:define-contact-set "anode" 4  (color:rgb 1 0 0 ) "##")
(sdegeo:define-contact-set "cathode" 4  (color:rgb 1 0 0 ) "##")

(sdegeo:set-current-contact-set "anode")
(sdegeo:set-contact-edges (find-edge-id (position 0 W 0)))

(sdegeo:set-current-contact-set "cathode")
(sdegeo:set-contact-boundary-edges (find-material-id "Aluminum"))

(entity:delete (find-material-id "Aluminum"))






(sdedr:define-constant-profile "ConstantProfileDefinition_1" "BoronActiveConcentration" Plow)
(sdedr:define-constant-profile-material "ConstantProfilePlacement_1" "ConstantProfileDefinition_1" "Silicon")


(sdedr:define-refinement-size "RefinementDefinition_1" (* 0.1 L) (/ W 20.0) 1 0.05 0.05 0.05 )
(sdedr:define-refinement-placement "RefinementPlacement_1" "RefinementDefinition_1" (list "material" "Silicon" ) )
(sdedr:define-refinement-function "RefinementDefinition_1" "DopingConcentration" "MaxTransDiff" 1)

(sde:build-mesh "snmesh" " " "n@node@_msh")







